freeslot("MT_DUMROCK", "S_DUM_SLIDE", "sfx_djmpm2", "sfx_djmpm1", "S_PLAY_DUMPOSE", "S_PLAY_FAKERUN", "sfx_bakflp", "S_DUMM_CROUCH", "sfx_tjump2", "sfx_tjump3", "sfx_spindm", "S_PLAY_FRONTFLIPO", "S_PLAY_FRONTFLIPT", "S_PLAY_SWAPJUMP")
sfxinfo[sfx_tjump2].caption = "Skip"
sfxinfo[sfx_tjump3].caption = "Hop"
sfxinfo[sfx_djmpm1].caption = "Skip"
sfxinfo[sfx_djmpm2].caption = "Hops"
sfxinfo[sfx_spindm].caption = "Recurl"
sfxinfo[sfx_bakflp].caption = "Super Jump"
states[S_PLAY_FRONTFLIPO] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SWAPJUMP}
states[S_PLAY_FRONTFLIPT] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SPRING}
states[S_PLAY_SWAPJUMP] = {SPR_PLAY, SPR2_LAND, 8, nil, 0,  0, S_PLAY_SWAPJUMP}
states[S_DUMM_CROUCH] = {SPR_PLAY, SPR2_BNCE, 1, nil, 0, 0, S_DUMM_CROUCH}
states[S_DUM_SLIDE] = {SPR_PLAY, SPR2_GLID, 1, nil, 0, 0, S_DUM_SLIDE}
states[S_PLAY_FAKERUN] = {SPR_PLAY, SPR2_RUN_, 1, nil, 0,  0, S_PLAY_FAKERUN}
states[S_PLAY_DUMPOSE] = {SPR_PLAY, SPR2_TAL0, -1, nil, 0, 0, S_PLAY_DUMPOSE}

//particle junk
local jumpdust = function(inflictor, ns, item)
	for i = 1,12
		local fa = (i*ANG30)
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
			mo.momz = -ns*FRACUNIT/3
		end
		mo.destscale = $/5
		mo.scalespeed = FRACUNIT/12
		i = $+1
	end
end

local radibub = function(inf1, inf2)
	for i = 1, 6
		local booble = P_SpawnMobj(inf1.x+P_ReturnThrustX(nil,inf1.angle+(ANG60*i),FRACUNIT*50), inf1.y+P_ReturnThrustY(nil,inf1.angle+(ANG60*i),FRACUNIT*50), inf1.z, MT_MARINE_SUPER)
		booble.extravalue1 = inf2.drawangle
		booble.target = inf1
		booble.color = inf1.color
		booble.colorized = true
	end
end

local setpose = function(inflictor, pl)
	local alreadyposed = 0
	local oldmeme = 0
	if alreadyposed == 1 return end
	
	local framepose = P_RandomRange(0, 24)
	if framepose != 21 -- specifically the old one
		inflictor.frame = framepose
	else
		oldmeme = P_RandomRange(0, 2)
		if oldmeme == 2
			inflictor.frame = 21
			S_StartSound(inflictor, sfx_kc48) -- epic kart reference,,,,
		else
			inflictor.frame = P_RandomRange(0, 20) -- pick one of these instead
		end
	end
	if framepose == 24
		if pl.fadposestop == false -- frank
			if pl.powers[pw_super]
				inflictor.frame = 25
			else
				inflictor.frame = 24
			end
			S_StartSound(inflictor, sfx_fadswp)
			P_SpawnMobjFromMobj(inflictor, 0,0,-14*FRACUNIT, MT_FADS)
		else
			inflictor.frame = P_RandomRange(0, 20) -- pick one of these instead
		end
	end
	
	for i = 1, 5
		local sparkxs = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
		sparkxs.scale = inflictor.scale
		sparkxs.color = inflictor.color
		sparkxs.colorized = true
		sparkxs.momx = inflictor.momx + P_RandomRange(-10, 10)*inflictor.scale
		sparkxs.momy = inflictor.momy + P_RandomRange(-10, 10)*inflictor.scale
		sparkxs.momz = inflictor.momz + P_RandomRange(-2, 7)*inflictor.scale
	end
	pl.posetimer = 43
	alreadyposed = 1
end

local betterROF = function(inflictor)
	for i = 1,36
		local mf = P_SPMAngle(inflictor,MT_DUMFIRE,inflictor.angle+(ANG10*i),1)
		if mf and mf.valid
			mf.fuse = TICRATE
			mf.target = inflictor
			P_InstaThrust(mf,mf.angle,10*FRACUNIT)
			mf.frame = FF_FULLBRIGHT|FF_TRANS70
			mf.blendmode = AST_ADD
			mf.colorized = false
			if G_RingSlingerGametype() or CBW_Battle
				mf.color = inflictor.color 
				mf.colorized = true
			end
		end
	end	
end

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
		if S_MusicName(player) == "_drown" and not player.powers[pw_super]
			P_RestoreMusic(player)
		end
		player.powers[pw_underwater] = 0
		player.powers[pw_spacetime] = 0
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE 
		if player.mo.state == S_PLAY_SWAPJUMP
			if (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz >= 0
				player.mo.state = S_PLAY_FALL
			end
			
			if not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz <= 0
				player.mo.state = S_PLAY_FALL
			end
		end
		
		
		if not (player.cmd.buttons & BT_SPIN) then -- Begin new lines
			player.spintapready = true
			player.dumspintap = false
		elseif player.spintapready then
			player.dumspintap = true
			player.spintapready = false
		else
			player.dumspintap = false
		end
		
		player.cantrick = false //disable xmom tricks cause they dont wanna cooperate with me >:(
		player.spcanflip = false

		//measure jumps
		if player.jumpnumber == nil
			player.jumpnumber = 0 
			player.justjumped = 0
			player.jumpcheck = 0
			player.fadposestop = false -- hi!!!!!!!
		end
		if player.dumsqeesh == nil
			player.dumsqeesh = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and player.jumpcheck == 0 
			player.jumpnumber = 0 
		end
		//recurl checker for fadswap
		if player.canrecurl == nil
		or P_IsObjectOnGround(player.mo)
			player.canrecurl = 0
		end
		
		//to prevent immediate double or triple jump
		if player.usedown == nil 
		or not (player.cmd.buttons & BT_JUMP) 
			player.usedown = 0
			player.justjumped = 0 
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_JUMP) 
			player.usedown = 1 
		end
		
		if (player.cmd.buttons & BT_JUMP) and (player.cmd.buttons & BT_SPIN)
			player.fuckingstopthx = 1
		else
			player.fuckingstopthx = 0
		end
		
		if player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1
			if not (leveltime%4) and (player.mo.sprite2 != FF_SPR2SUPER|SPR2_TRNS)
				local water = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-24, 24)*player.mo.scale, P_RandomRange(-24, 24)*player.mo.scale, player.mo.height/2+P_RandomRange(-20, 20)*player.mo.scale, MT_MARINE_BUBBLE)
				water.color = player.mo.color
				water.colorized = true
				water.scale = P_RandomRange($, $*7/5)
				water.fuse = TICRATE*6
				if not (leveltime%34)
					water.state = S_MARINE_LARGE
				end
			end
		end

		//to prevent immediate recurl
		if player.spindown == nil 
		or not (player.cmd.buttons & BT_SPIN) 
			player.spindown = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_SPIN) 
			player.spindown = 1 
			player.usedown = 1 
		end
		
		if player.rings >= 50 and not player.powers[pw_super] and All7Emeralds(emeralds) and (player.powers[pw_shield] & SH_NOSTACK) == SH_NONE and not (player.solchar and player.solchar.istransformed)
		and (player.pflags & PF_JUMPED)
		and player.spindown == 0
		and player.cmd.buttons & BT_SPIN
			player.spindown = 1 
			player.pflags = $|PF_THOKKED
		end
			
		//----------------------------------------------------------------------
		if player.pflags & PF_JUMPED 
		and player.cmd.buttons & BT_SPIN
		and player.cmd.buttons & BT_JUMP 
		and player.jumpnumber == 0
			player.jumpnumber = 1
		end
		
		if player.pflags & PF_JUMPED 
		and player.usedown == 0 
		and not (player.pflags & PF_THOKKED) 
		and player.cmd.buttons & BT_JUMP 
		and player.jumpcheck == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
			player.jumpcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (player.pflags & PF_SPINNING) 
		and not (player.pflags & PF_STARTDASH) 
		and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
		and player.jumpcheck == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		or player.jumpcheck == 1
		and not P_IsObjectOnGround(player.mo)
		and player.iscrouching == 0
		and not (player.mo.boat and player.mo.boat.valid)
			
			//first jump
			if player.jumpnumber == 0 
				player.justjumped = 1 
				player.jumpnumber = 1 //you just jumped weenie congrats
				player.pflags = $1|PF_JUMPED 
				player.pflags = $1 & ~PF_SPINNING
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/18) + (player.mo.momz))
				end
				player.canuncrl = 0
				player.backflipped = 0
				player.forcestop = 0
				player.attrac = 0
				player.chargetime = 0
				player.chargemeter = 0
				player.oknowyoucandoit = 0
				player.canrecurl = 0
				player.flamehover = 0
				player.trailstop = 0
			end
			
			//second jump
			if player.jumpnumber == 1 
			and player.justjumped == 0 
			and not (P_PlayerInPain(player)) 
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not P_IsObjectOnGround(player.mo)
			and player.homing == 0
			and not player.dumspintap
				player.justjumped = 1 
				player.jumpnumber = 2 
				player.pflags = $1 & ~PF_JUMPED 
				player.mo.state = S_PLAY_FRONTFLIPO
				player.pflags = $1 & ~PF_SPINNING
				S_StartSound(player.mo, mariomode and sfx_djmpm1 or sfx_tjump2)
				P_DoJump(player, false) //the jump
				player.mo.momz = $*9/10
				//xmom speed boost
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/16) + (player.mo.momz))
				end
				//shieldz
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_wdjump)
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
				end
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_s3k45)
					jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
				end
				
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 5 << FRACBITS, MT_MEDIUMBUBBLE)
				else
					jumpdust(player.mo, 5*player.mo.scale, MT_DUST)
				end
			end
			
			//third jump
			if player.jumpnumber == 2 
			and player.justjumped == 0 
			and not (P_PlayerInPain(player))
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and player.homing == 0
			and not player.dumspintap
				player.mo.state = S_PLAY_FRONTFLIPT 
				player.justjumped = 1 
				player.jumpnumber = 3 
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_JUMPED 
				S_StartSound(player.mo, mariomode and sfx_djmpm2 or sfx_tjump3)
				P_DoJump(player, false) //the jump
				player.mo.momz = $*4/5
				
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/15) + (player.mo.momz))
				end
				//shield
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_wdjump)
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
				end
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_s3k45)
					jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
				end
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 5 << FRACBITS, MT_MEDIUMBUBBLE)
				else
					jumpdust(player.mo, 5*player.mo.scale, MT_DUST)
				end
			end
			player.jumpcheck = 0
			player.usedown = 1 	
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpnumber = 0
		end
		
		
		//jump whenever
		if not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_JUMPED)
		and (player.cmd.buttons & BT_JUMP)
		and player.usedown == 0
		and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.fuckingstopthx == 0
		and player.jumpnumber < 3
			player.pflags = $|PF_JUMPED
			player.pflags = $1 & ~PF_THOKKED
			if player.jumpnumber == 0
				player.jumpnumber = 1
			end
			player.canuncrl = 0
			player.canrecurl = 0
			player.oknowyoucandoit = 0
		end	
			
		
		//making sure things dont get fuckd
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		//reset jumps if carried
		if player.powers[pw_carry]
		or player.powers[pw_carry] == CR_MACESPIN
			player.jumpcheck = 0 
			player.jumpnumber = 0
		end
		
		if (player.mo.boat and player.mo.boat.valid)
			player.jumpnumber = 69
		end
		
		//self explanatory
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		//stop freaking out when you jump the second you hit the ground
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.cmd.buttons & BT_JUMP
			player.jumpnumber = 1
		end
		
		//you too
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.pflags & PF_JUMPED
		or P_IsObjectOnGround(player.mo) and player.pflags & PF_JUMPED
			player.jumpnumber = 1
		end
	end
end)

//rolling and crouching time
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE
		
		if player.SHUTUPDUMMIE == nil
			player.SHUTUPDUMMIE = 0
		end
		
		if player.SHUTUPDUMMIE == 1 return end
		
		if player.cancrouch == nil //crouching junk
			player.cancrouch = 1
			player.iscrouching = 0
		end
		
		//dont want these to fuck up stuff
		if not (player.powers[pw_carry] == CR_NIGHTSMODE)
		and not (player.powers[pw_carry])
		and not (player.exiting)
		
			//fuck
			local sextors = P_PlayerTouchingSectorSpecial(player, 0, 0)
			
			if player.waitasec == nil
				player.waitasec = 0
			end	

			if (player.mo.state == S_PLAY_WALK or (player.speed < 28*player.mo.scale and not (player.powers[pw_super])) or (player.speed < 45*player.mo.scale and (player.powers[pw_super])))
			and not (player.pflags & PF_SPINNING)
			and P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_STARTDASH)
			or player.skidtime
				player.charability2 = CA2_NONE
				player.cancrouch = 1
			else
				if player.skidtime return end
				player.charability2 = CA2_SPINDASH
				player.cancrouch = 0
			end					
			
			if player.fadswapped == nil
				player.fadswapped = 0
			end
			
			//lets dive right into the crouch first
			
			if player.dummiegroovin
				player.cancrouch = 0
				player.iscrouching = 0
				player.height = skins[player.mo.skin].height
			end
			
			if player.slidebounce == nil or not (player.cmd.buttons & BT_SPIN)
				player.slidebounce = 0 
			end
			
			if (player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(player))
			and P_IsObjectOnGround(player.mo)
			and player.cancrouch == 1
			and (player.mo.state == S_PLAY_WALK or (player.speed < 28*player.mo.scale and not (player.powers[pw_super])) or (player.speed < 45*player.mo.scale and (player.powers[pw_super])))
			and player.waitasec != 1 
			and player.waitasec != 2
			and player.mo.state != S_PLAY_PAIN
				if player.mo.state != S_DUMM_CROUCH
				and not player.dummiegroovin
				and not (player.pflags & PF_STARTDASH)
					if player.speed == 0
						player.mo.state = S_DUMM_CROUCH
					else
						player.mo.state = S_DUM_SLIDE
						player.slidebounce = 1
					end
				end
				player.iscrouching = 1
				player.height = (skins[player.mo.skin].height)*6/10
			end
			
			//what the fuck are you doing stop moving
			if (player.mo.state == S_DUMM_CROUCH or player.mo.state == S_DUM_SLIDE)
				if (player.cmd.buttons & BT_JUMP)
					player.pflags = $|PF_FULLSTASIS
				else
					player.pflags = $|PF_STASIS
				end
			end
			
			if not (leveltime % 3) and player.mo.state == S_DUM_SLIDE then
				P_SpawnSkidDust(player, player.mo.radius, true)
			end
			
			if player.slidesquish == nil
				player.slidesquish = 0 
				player.damnitbubs = false
				player.ctffucker = false
			end
			
			if player.slidebounce == 1 and player.mo.state == S_DUMM_CROUCH then
				player.slidesquish = 1
				S_StartSound(player.mo, sfx_s3k9a)
				player.slidebounce = 0
			end
			
			//currently crouching..
			if player.iscrouching == 1
			and player.backflipped == 0
			and not (P_PlayerInPain(player))
			and player.waitasec != 1 
			and player.waitasec != 2
				player.oknowyoucandoit = 1
				if player.mo.state != S_DUMM_CROUCH
				and not player.dummiegroovin
				and not (player.pflags & PF_STARTDASH)
					if player.speed == 0
						player.mo.state = S_DUMM_CROUCH
					else
						player.mo.state = S_DUM_SLIDE
						player.slidebounce = 1
					end
				end
				
				if (P_PlayerInPain(player))
				or not player.mo.health
				or not (player.cmd.buttons & BT_SPIN)
				or not P_IsObjectOnGround(player.mo)
					if (player.mo.state == S_DUMM_CROUCH or player.mo.state == S_DUM_SLIDE)
						player.mo.state = S_PLAY_STND
					end
					player.height = skins[player.mo.skin].height
					player.iscrouching = 0
				end
				
				//WOOOOOOO BACKFLIP
				if (player.cmd.buttons & BT_JUMP)
				and not (player.pflags & PF_FULLSTASIS)
				and not player.dumspintap
					if not player.ctffucker
						player.oknowyoucandoit = 0
						P_SetObjectMomZ(player.mo, 8*player.mo.scale, true)
						//shieldz
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
							P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
							S_StartSound(player.mo, sfx_wdjump)
							jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
							jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
						end
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
							P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
							S_StartSound(player.mo, sfx_s3k45)
							jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
						end
						if player.solchar and player.solchar.istransformed
							radibub(player.mo, player)
						end
						
						if player.hyper and player.hyper.capable and player.powers[pw_super]
							player.mo.momz = $*13/10
						end
						
						if player.mo.eflags & MFE_UNDERWATER
						and not (player.mo.eflags & MFE_TOUCHWATER)
							player.mo.momz = $*6/8
						end
						player.jumpnumber = 4
						if player.mo.eflags & MFE_UNDERWATER -- dust time
							jumpdust(player.mo, 9 << FRACBITS, MT_MEDIUMBUBBLE)
						else
							jumpdust(player.mo, 9*player.mo.scale, MT_DUST)
						end
						player.backflipped = 1
					else
						P_SetObjectMomZ(player.mo, 2*FRACUNIT, true)
						P_InstaThrust(player.mo, (player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)), player.speed + 11*FRACUNIT)
						local lungeitem = MT_DUST
						S_StartSound(player.mo, sfx_s238)
						if player.mo.eflags & MFE_UNDERWATER or (player.mo.eflags & MFE_TOUCHWATER)
							lungeitem = MT_MEDIUMBUBBLE
						end
						for i = 1,10 --dust,
							local fa = -player.mo.angle + P_RandomRange(-100, 100) - ANGLE_90
							local mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, lungeitem)
							mo.scale = player.mo.scale
							if mo and mo.valid 
								if (lungeitem == MT_DUST)
									mo.momy = FixedMul(cos(fa), 8 << FRACBITS) + P_RandomRange(-6, 6)*player.mo.scale
									mo.momx = FixedMul(sin(fa), 8 << FRACBITS) + P_RandomRange(-6, 6)*player.mo.scale
									mo.momz = P_RandomRange(-1, 3)*player.mo.scale/P_MobjFlip(player.mo)
								else
									mo.momy = FixedMul(cos(fa), 10 << FRACBITS) + P_RandomRange(-5, 5)*player.mo.scale
									mo.momx = FixedMul(sin(fa), 10 << FRACBITS) + P_RandomRange(-5, 5)*player.mo.scale
									mo.momz = P_RandomRange(-5, 1)*player.mo.scale/P_MobjFlip(player.mo)
								end
							end
						end
					end
					S_StartSound(player.mo, sfx_bakflp)
					player.pflags = $1 & ~PF_NOJUMPDAMAGE
					player.flags = SF_NOSPINDASHDUST|SF_SUPER //so you can break shit airborn
					player.mo.state = S_PLAY_ROLL
				end
			end
			
			//backflip trails
			if (player.mo.momz < 0  and not (player.mo.eflags & MFE_VERTICALFLIP) or player.mo.momz > 0 and (player.mo.eflags & MFE_VERTICALFLIP))
				player.trailstop = 1
			end
			if player.jumpnumber == 4
			and not (P_IsObjectOnGround(player.mo))
			and player.trailstop == 0
			and (player.mo.state == S_PLAY_ROLL or player.ctffucker)
				local backtrail = P_SpawnGhostMobj(player.mo)
				backtrail.color = player.mo.color
				backtrail.colorized = true
				backtrail.fuse = 4
				backtrail.blendmode = AST_ADD
				if (player.mo.momz > 0  and not (player.mo.eflags & MFE_VERTICALFLIP) or player.mo.momz < 0 and (player.mo.eflags & MFE_VERTICALFLIP))
				and (player.cmd.buttons & BT_JUMP) //holding jump
					P_SpawnGhostMobj(backtrail)
				end
			end
			
			//you should probably start rolling when you hit a spring while crouching, help keep the game feel consistent
			if (player.mo.eflags & MFE_SPRUNG)
			and P_IsObjectOnGround(player.mo)
			and player.iscrouching == 1
				player.cancrouch = 0
				player.mo.state = S_PLAY_ROLL
				S_StartSound(player.mo, sfx_spin)
				player.pflags = $|PF_SPINNING
				player.height = skins[player.mo.skin].height
				player.iscrouching = 0
			end
			
			//okay now to start worrying about the air dash
			if player.pflags & PF_STARTDASH
			and P_IsObjectOnGround(player.mo)
			and player.waitasec == 0
				player.pflags = $1 & ~PF_STARTDASH
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_STND 
			end
			
			if S_SoundPlaying(player.mo, sfx_spndsh) and P_IsObjectOnGround(player.mo) //bro shut up 
				S_StopSoundByID(player.mo, sfx_spndsh)
			end
			
			if player.canuncrl == nil
			or P_IsObjectOnGround(player.mo)
			or (player.mo.eflags & MFE_JUSTHITFLOOR)
				player.posetimer = 0
				player.canuncrl = 0
				player.backflipped = 0
				player.forcestop = 0
				player.attrac = 0
				player.chargetime = 0
				player.chargemeter = 0
				player.oknowyoucandoit = 0
				player.canrecurl = 0
				player.flamehover = 0
				player.trailstop = 0
				player.flags = SF_NOJUMPSPIN|SF_MARIODAMAGE|SF_NOSPINDASHDUST|SF_SUPER
			end
			
			if (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
			and not (player.exiting)
				player.spindown = 1
			end
			
			local attraclook = P_LookForEnemies(player, false, false)
			player.mo.target = attraclook
			player.mo.tracer = attraclook
			
			if (player.mo.eflags & MFE_SPRUNG)
			and player.chargetime != 0
			and player.chargetime <= 100
				player.chargetime = 0
				player.chargemeter = 0
				player.spindown = 1
				player.flamehover = 26
				player.flags = SF_NOJUMPSPIN|SF_MARIODAMAGE|SF_NOSPINDASHDUST|SF_SUPER
				player.firedrop = 0
			end
			
			if player.mo.state == S_PLAY_FALL
			and player.chargetime > 0
			or (player.mo.state == S_PLAY_SUPER_TRANS1)
				player.oknowyoucandoit = 1
			end
			
			//Airborn Spindash Baybeeeee
			if (player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(player))
			and not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and player.spindown == 0 
			and player.canrecurl == 0 //didnt dash yet
			and player.chargetime <= 100
			and (player.powers[pw_shield] & SH_NOSTACK) != SH_ARMAGEDDON //so you can do a funny
			and player.mo.state != S_PLAY_PAIN
			and player.oknowyoucandoit == 0
			and not player.damnitbubs
			and not player.ctffucker
			and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and player.jumpnumber != 3 and attraclook and attraclook.valid and player.chargetime == 1)
				player.flags = SF_NOSPINDASHDUST|SF_SUPER //so you can break shit airborn
				player.pflags = $1 & ~PF_NOJUMPDAMAGE
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $|PF_JUMPED|PF_STARTDASH
				player.usedown = 1
				player.mo.momx = 0
				player.mo.momy = 0
				player.speed = 0
				player.jumpcheck = 0
				player.mo.state = S_PLAY_SPINDASH
				player.drawangle = player.mo.angle
				player.chargetime = $ + 1
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and player.jumpnumber != 3 and attraclook and attraclook.valid and player.chargetime == 1
					player.chargetime = 102
				end
				
				if player.chargemeter == 0 //set it to the default
					player.chargemeter = 15
					player.mo.momz = 0
				end
				if not (player.powers[pw_shield] & SH_FORCE) and player.chargetime >= 40
					player.mo.momz = $ - P_GetMobjGravity(player.mo)*8/9
				elseif (player.powers[pw_shield] & SH_FORCE) or player.chargetime < 40
					player.mo.momz = 0
					if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP or (player.powers[pw_shield] & SH_FORCE) or (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
						player.pflags = $1|PF_SHIELDABILITY
					end
				end
				
				if player.mo.momz > 0  and not (player.mo.eflags & MFE_VERTICALFLIP)
				or player.mo.momz < 0  and (player.mo.eflags & MFE_VERTICALFLIP)
					player.mo.momz = $ * -1
				end
				player.chargemeter = $ + 1
				if player.chargemeter >= 50 //lock it at 50
					player.chargemeter = 50
				end
				//sounds and fx
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP or (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
					player.dumaim1 = player.mo.z - 45*FRACUNIT*P_MobjFlip(player.mo)
					player.dumaim2 = player.mo.z - 85*FRACUNIT*P_MobjFlip(player.mo)
					player.dumaim3 = player.mo.z - 125*FRACUNIT*P_MobjFlip(player.mo)
				else
					player.dumaim1 = player.mo.z
					player.dumaim2 = player.mo.z
					player.dumaim3 = player.mo.z
				end
				
				local daim1 = P_SpawnMobj(player.mo.x+P_ReturnThrustX(nil,player.mo.angle,FRACUNIT*50), player.mo.y+P_ReturnThrustY(nil,player.mo.angle,FRACUNIT*50), player.dumaim1, MT_DUMAIM)
				daim1.color = player.mo.color
				daim1.scale = player.mo.scale
				local daim2 = P_SpawnMobj(player.mo.x+P_ReturnThrustX(nil,player.mo.angle,FRACUNIT*100), player.mo.y+P_ReturnThrustY(nil,player.mo.angle,FRACUNIT*100), player.dumaim2, MT_DUMAIM)
				daim2.color = player.mo.color
				daim2.scale = player.mo.scale
				local daim3 = P_SpawnMobj(player.mo.x+P_ReturnThrustX(nil,player.mo.angle,FRACUNIT*150), player.mo.y+P_ReturnThrustY(nil,player.mo.angle,FRACUNIT*150), player.dumaim3, MT_DUMAIM)
				daim3.color = player.mo.color
				daim3.scale = player.mo.scale
				
				if player.chargetime == 1 or (player.chargetime%10 == 0 and player.chargetime < 52)
					S_StartSound(player.mo, sfx_spndsh)
					local funnythokie = P_SpawnMobjFromMobj(player.mo, 0,0,-4*FRACUNIT, MT_DUMTHOK)
					funnythokie.color = player.mo.color
					funnythokie.colorized = true
					if player.solchar and player.solchar.istransformed
						radibub(player.mo, player)
					end
				end
				
				if player.chargetime == 100 and (player.powers[pw_shield] & SH_NOSTACK) != SH_ATTRACT
					player.airtrail = 1
				end
				if player.airtrail == 1 //abusing the hover? too bad go fall bye
					S_StartSound(player.mo, sfx_s3k51)
					player.airtrail = 2
					player.mo.state = S_PLAY_FALL
				end
			end
			
			//do the dash
			if not (player.cmd.buttons & BT_SPIN)
			and player.chargetime != 0
			and player.chargetime != 102
			and not (P_PlayerInPain(player))
			and not P_IsObjectOnGround(player.mo)
			and not (player.powers[pw_carry])
			and player.oknowyoucandoit == 0
				if player.chargetime <= 100
					P_InstaThrust(player.mo, player.mo.angle, player.chargemeter*player.mo.scale)
					player.charability2 = CA2_SPINDASH
					player.pflags = $1 & ~PF_JUMPED
					S_StartSound(player.mo, sfx_zoom)
					player.pflags = $|PF_SPINNING
					if player.powers[pw_super]
					or (player.solchar and player.solchar.istransformed)
						P_InstaThrust(player.mo, player.mo.angle, player.chargemeter*player.mo.scale + 22*player.mo.scale)
					end
					if player.hyper and player.hyper.capable and player.powers[pw_super]
						P_InstaThrust(player.mo, player.mo.angle, player.chargemeter*player.mo.scale + 35*player.mo.scale)
					end
					//shields
					if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL //fast drop	
					or (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
						P_SetObjectMomZ(player.mo, -33*FRACUNIT, true)
						player.pflags = $1|PF_SHIELDABILITY
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
							S_StartSound(player.mo, sfx_s3k44)
						end
						player.canuncrl = 1
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							player.pflags = $ & ~PF_SHIELDABILITY
							player.firedrop = 1
							player.canuncrl = 1
						end
						player.jumpnumber = 5
					elseif (player.powers[pw_shield] & SH_FORCE) //momentum fucker
						S_StartSound(mo, sfx_ngskid)
						player.pflags = $1|PF_SHIELDABILITY
						if player.forcestop == 0
							player.mo.momz = 0
							player.forcestop = 1
						end
					elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA //gain speed 
						if player.forcestop == 0
							P_InstaThrust(player.mo, player.mo.angle, player.chargemeter*player.mo.scale + 15*FRACUNIT) 
							player.forcestop = 1
							player.pflags = $1|PF_SHIELDABILITY
							S_StartSound(player.mo, sfx_s3k43)
							player.flamehover = 1
						end
					end

				end
				player.chargetime = 102
				player.canrecurl = 1 //cant dash again until you land
				player.jumpcheck = 0
				player.mo.state = S_PLAY_ROLL
				player.flags = SF_NOJUMPSPIN|SF_MARIODAMAGE|SF_NOSPINDASHDUST|SF_SUPER
			end
			
			if player.flamehover >= 1
			and player.flamehover <= 25
				player.flamehover = $ + 1
				player.mo.momz = 0
				if (player.cmd.buttons & BT_JUMP) and (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA and (player.pflags & PF_SHIELDABILITY)
				or (P_PlayerInPain(player))
				or player.powers[pw_pushing]
					player.flamehover = 26
					player.pflags = $ & ~PF_SHIELDABILITY
					player.pflags = $ & ~PF_SPINNING
					S_StartSound(player.mo, sfx_s3k47)
					for i = 1, 6
						local sparkxs = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						sparkxs.state = S_SPINDUST_FIRE1
						sparkxs.momx = player.mo.momx + P_RandomRange(-5, 5)*FRACUNIT
						sparkxs.momy = player.mo.momy + P_RandomRange(-5, 5)*FRACUNIT
						sparkxs.momz = player.mo.momz + P_RandomRange(-1, 2)*FRACUNIT
					end
				end
			end
			
			//attract
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT 
			and player.oknowyoucandoit == 1
			and player.mo.state == S_PLAY_FALL
			and not player.mo.state == S_PLAY_ROLL
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
			end
			
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and attraclook and attraclook.valid)
			and (player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(player))
			and not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not (player.pflags & PF_STARTDASH)
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and player.spindown == 0
				if attraclook and attraclook.valid
					player.pflags = $|PF_SHIELDABILITY
					player.jumpnumber = 1
					player.homing = 3*TICRATE
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, attraclook.x, attraclook.y)
					S_StartSound(player.mo, sfx_s3k40)
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
					player.oknowyoucandoit = 1
					player.spindown = 1
				end	
			end	
			
			//nuke boy
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON
			and (player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(player))
			and not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and player.spindown == 0
			and player.canrecurl == 0
			and player.damnitbubs == false
				jumpdust(player.mo, 12*player.mo.scale, MT_SUPERSPARK)
				P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EXPLODE)
				P_NukeEnemies(player.mo, player.mo, 800*player.mo.scale)
				P_FlashPal(player, PAL_NUKE, 10)
				player.powers[pw_shield] = SH_NONE
				S_StartSound(player.mo, sfx_bkpoof)
				P_StartQuake(20*FRACUNIT, 5)
				player.canrecurl = 1 //skip spindashing
				player.mo.state = S_PLAY_ROLL
				P_SetObjectMomZ(player.mo, 15*FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
			end
			
			//booble
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP and (player.pflags & PF_THOKKED) and player.fadswapped == 0
			and player.damnitbubs == false
				player.pflags = $ & ~PF_THOKKED
				player.mo.state = S_PLAY_SPRING
				player.jumpnumber = 1
				player.canuncrl = 0
				player.chargetime = 0
				player.chargemeter = 0
				player.oknowyoucandoit = 0
				player.canrecurl = 0
				player.trailstop = 0
				S_StartSound(player.mo, sfx_bnce1)
				P_SetObjectMomZ(player.mo, 20*FRACUNIT)
				if player.mo.eflags & MFE_UNDERWATER
				and not (player.mo.eflags & MFE_TOUCHWATER)
					player.mo.momz = $*3/5
				end
			end
			
			//attracted
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT  
				if(player.pflags & PF_SHIELDABILITY)
				and player.mo.momz > 6*FRACUNIT
					P_SetObjectMomZ(player.mo, 6*FRACUNIT)
					player.pflags = $ & ~PF_SHIELDABILITY
					player.pflags = $|PF_SPINNING
					player.mo.state = S_PLAY_ROLL
				end
			end
			
			if player.homing != 0
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
			end
			
			
			if not (player.cmd.buttons & BT_SPIN)
			and player.spindown == 1
				player.spindown = 0
			end
			
			//elemndeez nuts
			if player.mo.momz > 0  and not (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.firedrop == 1
			or player.mo.momz < 0  and (player.mo.eflags & MFE_VERTICALFLIP) and not (player.mo.eflags & MFE_SPRUNG) and player.firedrop == 1
				player.mo.momz = $ * -1
			end
			
			if player.firedrop == 1
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z + (P_RandomRange(-3,32)*player.mo.scale),MT_WATERDROP)
				player.canuncrl = 1
				player.canrecurl = 1
				player.trailstop = 1
				
				if (P_PlayerInPain(player))
				or P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				or player.canuncrl == 0
				or player.canrecurl == 0
				or player.powers[pw_carry]
				or (tracer and tracer.type == MT_TUBEWAYPOINT) 
				or player.mo.state == S_PLAY_DEAD
				or (player.mo.eflags & MFE_SPRUNG)
					player.firedrop = 0
				end
			end
			
			if player.ringcooldown == nil
			or (player.powers[pw_shield] & SH_NOSTACK) != SH_ELEMENTAL
				player.ringcooldown = 0
			end
			
			if player.ringcooldown != 0
				if player.ringcooldown == 1 and (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
					local FLASHD = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_DUMTHOK)
					FLASHD.color = SKINCOLOR_WHITE
					FLASHD.frame = A|FF_FULLBRIGHT
					FLASHD.blendmode = AST_ADD
					FLASHD.destscale = $*40
					S_StartSound(player.mo, sfx_tink)
				end
				player.ringcooldown = $-1
			end
			
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL -- the actual ability once you land
			and ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
			and player.firedrop == 1
				if player.ringcooldown == 0
					betterROF(player.mo)
					player.ringcooldown = 3*TICRATE
				end
				S_StartSound(player.mo, sfx_s3k4c)
				S_StartSound(player.mo, sfx_kc5b)
				P_StartQuake(30*FRACUNIT, 4)
				player.pflags = $ & ~PF_SHIELDABILITY
				P_InstaThrust(player.mo, player.drawangle, player.speed + 17*FRACUNIT) -- give a little boost
				for i = 1, 5
					local coughr = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_DUST)
					coughr.momx = P_RandomRange(-10, 10)*FRACUNIT
					coughr.momy = P_RandomRange(-10, 10)*FRACUNIT
					coughr.momz = P_RandomRange(-2, 2)*FRACUNIT
				end
				player.firedrop = 0
				player.canuncrl = 1
				player.canrecurl = 1
				player.dumsqeesh = 1
				player.jumpnumber = 0
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
			end
			
			//SQUAORSH
			if player.dumsqeesh >= 1
				player.dumsqeesh = $+1	
				if player.dumsqeesh == 2 //squash
					player.mo.spritexscale = FRACUNIT*(2)
					player.mo.spriteyscale = FRACUNIT/(8)
				else
					if player.dumsqeesh < (6)
						player.squishfactor = 5
					else
						player.squishfactor = (player.dumsqeesh + 20)
					end
					player.mo.spritexscale = $ - FRACUNIT/player.squishfactor
					player.mo.spriteyscale = $ + FRACUNIT/player.squishfactor
				end
				
				if player.mo.spritexscale < FRACUNIT and player.dumsqeesh != 0
					player.mo.spritexscale = FRACUNIT
				end	
				if player.mo.spriteyscale > FRACUNIT and player.dumsqeesh != 0
					player.mo.spriteyscale = FRACUNIT
				end
			end
			if player.slidesquish >= 1
				player.slidesquish = $+1	
				if player.slidesquish == 2 //squash
					player.mo.spritexscale = FRACUNIT*(2)
					player.mo.spriteyscale = FRACUNIT/(2)
				else
					if player.slidesquish < (8)
						player.squishfactor = 5
					else
						player.squishfactor = (player.slidesquish + 20)
					end
					player.mo.spritexscale = $ - FRACUNIT/player.squishfactor
					player.mo.spriteyscale = $ + FRACUNIT/player.squishfactor
				end
				
				if player.mo.spritexscale < FRACUNIT and player.slidesquish != 0
					player.mo.spritexscale = FRACUNIT
				end	
				if player.mo.spriteyscale > FRACUNIT and player.slidesquish != 0
					player.mo.spriteyscale = FRACUNIT
				end
			end

			
			//extra check
			if (player.pflags & PF_SPINNING)
			and (player.cmd.buttons & BT_SPIN)
			and player.spindown == 0
			and player.canuncrl == 1
			and player.homing == 0
				if player.jumpnumber == 0
					player.jumpnumber = 1
				end
				player.pflags = $1 & ~PF_SPINNING
				player.spindown = 1
				player.mo.state = S_PLAY_FALL
				player.flags = SF_NOJUMPSPIN|SF_MARIODAMAGE|SF_NOSPINDASHDUST|SF_SUPER
			end
			
			if player.powers[pw_carry] == CR_ROLLOUT
				player.flags = SF_NOJUMPSPIN|SF_MARIODAMAGE|SF_NOSPINDASHDUST|SF_SUPER
				player.spindown = 1
				player.canrecurl = 1
				player.iscrouching = 0
			end
			
			//FUCK YOU DEEP SEA ZONE
			if S_SoundPlaying(player.mo, sfx_cdfm11)
			and not (player.cmd.buttons & BT_SPIN)
				S_StopSoundByID(player.mo, sfx_cdfm11)
			end		
			
			if player.waitasec == 1
				S_StartSound(mo, sfx_cdfm11)
				player.mo.state = S_PLAY_FAKERUN
				player.cancrouch = 0
				player.iscrouching = 0
				player.height = skins[player.mo.skin].height
				player.waitasec = 2
			end
			
			if player.waitasec == 2
			and not P_IsObjectOnGround(player.mo)
				player.waitasec = 0
			end
			
			if sextors and sextors.valid and P_IsObjectOnGround(player.mo)then
				for fof in sextors.ffloors()
					if fof.valid and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale
					or abs(fof.bottomheight - player.mo.z+player.mo.height) <= 40*player.mo.scale)
					and fof.master and fof.master.valid and fof.master.flags&ML_NOCLIMB
					and (fof.master.special == 153 or fof.master.special == 180
					or (fof.master.special >= 150 and fof.master.special <= 152)
					or (fof.master.special >= 190 and fof.master.special <= 195)
					or fof.master.special == 176 or fof.master.special == 177)
						if player.waitasec == 0
						and player.waitasec != 1
						and player.waitasec != 2
							player.waitasec = 1
						end
						player.pflags = $|PF_STARTDASH
						P_InstaThrust(player.mo,0,0)
					end
				end
			end
			
			//scuse me for a quick sec, just gotta set this up
			if player.posetimer == nil
				player.posetimer = 0
			end
			
			if player.gotflag -- nooo more abilities! CTF is finally balanced once again
				player.jumpnumber = 69
				player.canrecurl = 1
				player.ctffucker = true
			else
				player.ctffucker = false
			end
			
			if player.posetimer != 0
				player.posetimer = $-1
				if player.posetimer == 1 and player.mo.state == S_PLAY_DUMPOSE
					if player.mo.frame == 24 or player.mo.frame == 25
						S_StartSound(player.mo, sfx_cdfm16)
						P_SpawnMobjFromMobj(player.mo, 0,0,-14*FRACUNIT, MT_FADS)
					end
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.mo.state == S_PLAY_DUMPOSE and P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_STND
			end
		end
	end
end)

//floor uncurl
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE
		player.mo._prevspin = $!=nil and $ or false
		player.mo._spintime = (player.cmd.buttons & BT_SPIN) and ($ and $+1 or 1) or 0
		if (player.pflags & PF_SPINNING) and player.mo._prevspin and P_IsObjectOnGround(player.mo) and player.mo._spintime == 1
			player.pflags = $1 & ~PF_SPINNING
			player.mo.state = S_PLAY_RUN
		end
		player.mo._prevspin = player.pflags & PF_SPINNING
	end
end)

addHook("TouchSpecial", function(bubble, mo) //dont steal it >:(
	if mo and mo.valid and mo.player 
	and bubble and bubble.valid
	and (mo.skin == "dummie")
		return true
	end
end, MT_EXTRALARGEBUBBLE)

//battle time

local explodelol = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
	
		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue 
		end
		if FixedHypot(FixedHypot(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end
		P_DamageMobj(mo, inflictor, source, 1)
	end
end
mobjinfo[MT_DUMROCK] = { -- the rock maneuver
	spawnstate = S_ROCKCRUMBLEC,
	speed = 20*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	mass = 0,
	damage = 0,
	flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
}
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle 
		then
		ScriptLoaded = true 
		local B = CBW_Battle

		local BackDive = function(mo,doaction)
			local player = mo.player
			
			player.actiontext = "Feint Jump"
			player.actionrings = 10
			player.action2text = nil 
			player.action2rings = 0 
			
			
			if not(B.CanDoAction(player)) 
				player.actionstate = 0 
				return end	

			if player.actionstate == 0 
			and not (player.pflags & PF_STARTDASH)
			and not (player.pflags & PF_THOKKED)  
				if doaction == 1 
					player.actionstate = 1  
					player.actiontime = 0
					player.invtimeers = 3*TICRATE
					B.PayRings(player) 
					S_StartSound(mo,sfx_s3k3c)	
				end
			end
			
			if player.actionstate == 1 --windup
				player.jumpnumber = 4
				player.actiontime = $+1
				player.invtimeers = $-1
				player.spindown = 1
				player.canrecurl = 1
				player.pflags = $ & ~PF_SPINNING
				player.pflags = $ & ~PF_STARTJUMP
				player.actiontext = "Feint Jump Dive"
				player.actionrings = 0
				player.powers[pw_flashing] = 5 -- still need a better way to stay invincible without the flash but whatever
				player.mo.flags = $|MF_NOCLIPTHING
				
				local backtrail = P_SpawnGhostMobj(player.mo)
				backtrail.color = SKINCOLOR_SKY
				backtrail.colorized = true
				backtrail.fuse = 7
				backtrail.blendmode = AST_ADD
				
				if player.actiontime == 1 -- launch backwards
					P_SetObjectMomZ(player.mo, 13*FRACUNIT/B.WaterFactor(player.mo), false)
					player.speed = 0
					P_InstaThrust(player.mo, player.mo.angle, -12*FRACUNIT)
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
				end
				
				if player.mo.state != S_PLAY_ROLL and player.actiontime < 20
					player.mo.state = S_PLAY_ROLL
				end
				
				if player.actiontime == 20
					player.mo.state = S_PLAY_FALL
				end
				
				if doaction == 1 and player.actiontime >= 10 -- no way you pressed it again
					player.actionstate = 2
					player.actiontime = 0
					S_StartSound(mo,sfx_s23c)	
					player.pflags = $|PF_JUMPED
					player.mo.flags = $&~MF_NOCLIPTHING
				end
				
				if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) -- or just.. dont do your action ig
				or player.mo.momz <= -15*FRACUNIT  and not (player.mo.eflags & MFE_VERTICALFLIP)
				or player.mo.momz >= -15*FRACUNIT  and (player.mo.eflags & MFE_VERTICALFLIP)
				or player.invtimeers == 0
					if doaction == 1 return end -- WAIT
					player.actionstate = 0
					player.actiontime = 0
					B.ApplyCooldown(player,TICRATE)
					player.actiontext = "Feint Jump"
					player.flags = skins["dummie"].flags
					player.mo.flags = $&~MF_NOCLIPTHING
				end
			end
			
			if player.actionstate == 2 --The Midair junk
				player.actiontext = "Feint Jump Dive"
				player.actionrings = 0
				
				if player.actiontime == 0
					P_SetObjectMomZ(player.mo, -27*FRACUNIT, false)
					P_InstaThrust(player.mo, player.mo.angle, 32*FRACUNIT + player.speed)
					player.mo.state = S_PLAY_ROLL
					jumpdust(player.mo, 19*player.mo.scale, MT_DUST)
					player.actiontime = 1
					player.flags = SF_NOSPINDASHDUST|SF_SUPER
					player.pflags = $|PF_JUMPED
				end
				
				local backtrail = P_SpawnGhostMobj(player.mo)
				backtrail.color = SKINCOLOR_FLAME
				backtrail.colorized = true
				backtrail.fuse = 7
				backtrail.blendmode = AST_ADD
				
				if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
					explodelol(player.mo, player.mo, 80*player.mo.scale) -- the fakest hitbox youve ever seen
					player.pflags = $&~PF_JUMPED
					player.dumsqeesh = 1
					player.flags = skins["dummie"].flags
					player.actionstate = 0
					player.actiontime = 0
					S_StartSoundAtVolume(player.mo, sfx_kc3b, 100)
					S_StartSound(player.mo,sfx_s3k5f)
					P_StartQuake(10*FRACUNIT, 4)
					P_SetObjectMomZ(player.mo, 5*FRACUNIT/B.WaterFactor(player.mo), false)
					B.ApplyCooldown(player,TICRATE)
					player.actiontext = "Feint Jump"
					for i = 1,6
						local mf = P_SPMAngle(player.mo,MT_DUMROCK,player.mo.angle+(ANG60*i),1)
						if mf and mf.valid
							mf.fuse = TICRATE
							mf.momz = 8*player.mo.scale*P_MobjFlip(player.mo)/B.WaterFactor(player.mo)
							mf.target = player.mo
							P_InstaThrust(mf,mf.angle,4*FRACUNIT)
							mf.color = player.mo.color 
							mf.colorized = true
						end
					end
					player.speed = $/2
				end
			end
				
			if (P_PlayerInPain(player))
			or ((player.mo.eflags & MFE_SPRUNG) and player.actionstate != 0)
			or not player.mo.health
				player.actionstate = 0
				player.actiontime = 0
				player.flags = skins["dummie"].flags
				player.mo.flags = $&~MF_NOCLIPTHING
			end
		end
		
		local PriorityDummie = function(player)
			if player.actionstate == 1
				B.SetPriority(player,1,10,nil,0,9,"Feint Jump")
			end
			if player.actionstate == 2
				B.SetPriority(player,3,3,nil,3,3,"Feint Jump Dive")
			end
		end
		
		local ExhaustDummie = function(player) --fine, i'll nerf it >:(
			if player.powers[pw_shield] and (player.powers[pw_shield] & SH_NOSTACK) != SH_PITY
				player.canrecurl = 1
				player.damnitbubs = true
				return true
			else
				player.damnitbubs = false
			end
			return false
		end
		
		local CollideDummie = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			
			if plr[n1] and plr[n1].valid and plr[n1].actionstate == 2 
				S_StartSound(mo[n2], sfx_hit00)
				plr[n1].actionstate = 0
				plr[n1].actiontime = 0
				plr[n1].flags = skins["dummie"].flags
				mo[n1].state = S_PLAY_FALL
				B.ApplyCooldown(plr[n1],TICRATE)
				mo[n2].momz = 10*FRACUNIT
				P_InstaThrust(mo[n2], mo[n2].angle, -3*FRACUNIT)
			end
		end
		
		CBW_Battle.SkinVars["dummie"] = {
			flags = SKINVARS_GUARD,
			weight = 76,
			special = BackDive,
			func_priority_ext = PriorityDummie,
			func_collide = CollideDummie,
			guard_frame = 1,
			func_exhaust = ExhaustDummie,
		}
	end
end)


//fuck you we're doing funky poses after landing on an enemy
addHook("MobjDeath", function(mobj, mo, src)
	local player = mo and mo.valid and mo == src and mo.health
	if player and mo.skin == "dummie"
		 
		if P_MobjFlip(mo)*(mo.z - mobj.z + mobj.height/2*P_MobjFlip(mo)) > 0 and P_MobjFlip(mo) != -1
		or P_MobjFlip(mo)*(mo.z + mo.height - mobj.z + mobj.height/2*P_MobjFlip(mo)) > 0 and P_MobjFlip(mo) == -1
			if mo.state == S_PLAY_FALL
			or mo.state == S_PLAY_DUMPOSE
				mo.state = S_PLAY_DUMPOSE
				setpose(mo, mo.player)
			end
		end
	end
end)